using System;
using System.Collections;

namespace NumUtils.Interpolation
{
    public class Neville
    {

        public double ErrorInterpolationNeville;
//        public double ErrorInterpolationNeville2;
//        public double ErrorInterpolationNeville3;


        public double InterpolationNeville(double[] x, double[] y, double X, int NumPoints)
        {
            double[,] M = new double[NumPoints + 1, NumPoints + 1];
            for (int k = 0; k < NumPoints; k++)
            {
                M[k + 1, 1] = y[k];
            }
            for (int i = 2; i <= (NumPoints); i++)
            {
                for (int j = 2; j <= i; j++)
                {
                    if (x[i - 1] == x[i - j])
                    {
                        throw new System.Exception("Invalid paramter in NumUtils.Interpolation.Neville.InterpolationNeville. The values in x should be all different.");
                    }
                    M[i, j] = ((X - x[i - j]) * M[i, j - 1] - (X - x[i - 1]) * M[i - 1, j - 1]) / (x[i - 1] - x[i - j]);
                }
            }

            double e1 = Math.Abs(M[NumPoints, NumPoints] - M[NumPoints - 1, NumPoints - 1]);
            double e2 = Math.Abs(M[NumPoints, NumPoints] - M[NumPoints, NumPoints - 1]);

            if (e1  >= e2)
            {
                this.ErrorInterpolationNeville = e2;
            }
            else
            {
                this.ErrorInterpolationNeville = e1;
            }
            this.ErrorInterpolationNeville = e1;
//            this.ErrorInterpolationNeville2 = e1;
//            this.ErrorInterpolationNeville3 = e2;
            return M[NumPoints, NumPoints];
        }

    }


}
